# keystone.receipt.providers.fernet.core module

class keystone.receipt.providers.fernet.core.Provider(*args, **kwargs)

  Bases: `Provider`

  generate_id_and_issued_at(receipt)

    Generate a receipt based on the information provided.

    Parameters:

      receipt (keystone.models.receipt.ReceiptModel) – A receipt object containing information about the authorization context of the request.

    Returns:

      tuple containing an ID for the receipt and the issued at time of the receipt (receipt_id, issued_at).

  validate_receipt(receipt_id)

    Validate a given receipt by its ID and return the receipt_data.

    Parameters:

      receipt_id (str) – the unique ID of the receipt

    Returns:

      receipt data as a tuple in the form of:

    (user_id, methods, issued_at, expires_at)

    `user_id` is the unique ID of the user as a string `methods` a list of authentication methods used to obtain the receipt `issued_at` a datetime object of when the receipt was minted `expires_at` a datetime object of when the receipt expires

    Raises:

      keystone.exception.ReceiptNotFound – when receipt doesn’t exist.

this page last updated: 2026-06-11 21:52:50

Except where otherwise noted, this document is licensed under Creative Commons Attribution 3.0 License. See all OpenStack Legal Documents.

found an error? report a bug